#include <Windows.h>
#include <commctrl.h>
#include <tchar.h>
#include "resource.h"
#include "main.h"

LRESULT CALLBACK WndProc(HWND hWnd,
						 UINT msg,
						 WPARAM wParam,
						 LPARAM lParam)
{
	static HANDLE hFile;
	static OPENFILENAME ofn = {0};
	static TCHAR fn[256] = {0};
	static HWND hTab, hHp, hMaxHp;
	
	switch(msg){
	case WM_CREATE:{
		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = hWnd;
		ofn.lpstrFilter = _T("Cave Story EXE File (*.exe)\0*.exe\0\0");
		ofn.Flags = OFN_FILEMUSTEXIST;
		ofn.lpstrFile = fn;
		ofn.nMaxFile = 256;
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDM_OPEN:
			if(GetOpenFileName(&ofn) == 0){
				break;
			}
			if((hFile = CreateFile(fn, GENERIC_ALL, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE){
				MessageBox(hWnd, _T("t@C̃I[vɎs܂"), _T("G["), MB_OK);
				PostQuitMessage(0);
				break;
			}
			{
			int temp;
			char buf[256];
			DWORD brw;

			SetFilePointer(hFile, 0x000157A7, NULL, FILE_BEGIN);
			ReadFile(hFile, &temp, 4, &brw, NULL);
			SetDlgItemInt(hWnd, IDC_BOOSTER, temp, TRUE);
			SetFilePointer(hFile, 0x00014BCF, NULL, FILE_BEGIN);
			ReadFile(hFile, &temp, 2, &brw, NULL);
			SetDlgItemInt(hWnd, IDC_HP, temp, TRUE);
			SetFilePointer(hFile, 0x00014BD8, NULL, FILE_BEGIN);
			ReadFile(hFile, &temp, 2, &brw, NULL);
			SetDlgItemInt(hWnd, IDC_MAXHP, temp, TRUE);
			SetFilePointer(hFile, 0x0000F765, NULL, FILE_BEGIN);
			ReadFile(hFile, &temp, 1, &brw, NULL);
			SetDlgItemInt(hWnd, IDC_TITLEMAP, temp, TRUE);
			SetFilePointer(hFile, 0x0000F763, NULL, FILE_BEGIN);
			ReadFile(hFile, &temp, 1, &brw, NULL);
			SetDlgItemInt(hWnd, IDC_TITLEEVENT, temp, TRUE);
			SetFilePointer(hFile, 0x00093640, NULL, FILE_BEGIN);
			ReadFile(hFile, &temp, 4, &brw, NULL);
			SetFilePointer(hFile, temp - 0x00400000, NULL, FILE_BEGIN);
			for(temp = 0; temp < sizeof(buf); ++temp){
				ReadFile(hFile, &buf[temp], 1, &brw, NULL);
				if(&buf[temp] == '\0'){
					break;
				}
			}
			SetDlgItemTextA(hWnd, IDC_TITLE, buf);
			}
			break;
		case IDM_CLOSE:
			CloseHandle(hFile);
			SetDlgItemText(hWnd, IDC_BOOSTER, _T(""));
			SetDlgItemText(hWnd, IDC_HP, _T(""));
			SetDlgItemText(hWnd, IDC_MAXHP, _T(""));
			SetDlgItemText(hWnd, IDC_TITLEMAP, _T(""));
			SetDlgItemText(hWnd, IDC_TITLEEVENT, _T(""));
			break;
		case IDM_SAVE:{
			int temp;
			DWORD brw;
			char buf[256];

			SetFilePointer(hFile, 0x000157A7, NULL, FILE_BEGIN);
			temp = GetDlgItemInt(hWnd, IDC_BOOSTER, NULL, TRUE);
			WriteFile(hFile, &temp, 4, &brw, NULL);
			SetFilePointer(hFile, 0x000157BD, NULL, FILE_BEGIN);
			WriteFile(hFile, &temp, 4, &brw, NULL);
			SetFilePointer(hFile, 0x00014BCF, NULL, FILE_BEGIN);
			temp = (short)GetDlgItemInt(hWnd, IDC_HP, NULL, TRUE);
			WriteFile(hFile, &temp, 2, &brw, NULL);
			SetFilePointer(hFile, 0x00014BD8, NULL, FILE_BEGIN);
			temp = (short)GetDlgItemInt(hWnd, IDC_MAXHP, NULL, TRUE);
			WriteFile(hFile, &temp, 2, &brw, NULL);
			SetFilePointer(hFile, 0x0000F765, NULL, FILE_BEGIN);
			temp = (signed char)GetDlgItemInt(hWnd, IDC_TITLEMAP, NULL, TRUE);
			WriteFile(hFile, &temp, 1, &brw, NULL);
			SetFilePointer(hFile, 0x0000F763, NULL, FILE_BEGIN);
			temp = (signed char)GetDlgItemInt(hWnd, IDC_TITLEEVENT, NULL, TRUE);
			WriteFile(hFile, &temp, 1, &brw, NULL);
			SetFilePointer(hFile, 0x00093640, NULL, FILE_BEGIN);
			temp = 0x0048EF00;
			WriteFile(hFile, &temp, 4, &brw, NULL);
			SetFilePointer(hFile, 0x0008EF00, NULL, FILE_BEGIN);
			GetDlgItemTextA(hWnd, IDC_TITLE, buf, sizeof(buf));
			WriteFile(hFile, buf, strlen(buf), &brw, NULL);
			}
			break;
		}
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}

int WINAPI _tWinMain(HINSTANCE hInstance, 
					 HINSTANCE hPrevInstance,
					 PTSTR lpCmdLine,
					 int nCmdShow)
{
	HWND hwnd;
	MSG msg;
	WNDCLASSEX winc;
	BOOL bRet;

	winc.cbSize			= sizeof(WNDCLASSEX);
	winc.style			= CS_HREDRAW | CS_VREDRAW;
	winc.lpfnWndProc	= WndProc;
	winc.cbClsExtra		= 0;
	winc.cbWndExtra		= DLGWINDOWEXTRA;
	winc.hInstance		= hInstance;
	winc.hIcon			= (HICON)LoadImage(NULL, MAKEINTRESOURCE(IDI_APPLICATION), IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	winc.hIconSm		= NULL;
	winc.hCursor		= (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW), IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	winc.hbrBackground	= CreateSolidBrush(GetSysColor(COLOR_MENU));
	winc.lpszMenuName	= NULL;
	winc.lpszClassName	= _T("MAINWINDOW");

	if(RegisterClassEx(&winc) == 0){
		return 0;
	}

	hwnd = CreateDialog(hInstance, MAKEINTRESOURCE(MAINDIALOG), NULL, NULL);

	if (hwnd == NULL){
		return 0;
	}
	
	while(bRet = GetMessage(&msg, NULL, 0, 0)){
		if(bRet == -1){
			break;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return 0;
}
